Attribute VB_Name = "TextDraw"
Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

'lfCharSet Constants
Private Const ANSI_CHARSET = 0
Private Const DEFAULT_CHARSET = 1
Private Const SYMBOL_CHARSET = 2
Private Const SHIFTJIS_CHARSET = 128
Private Const HANGEUL_CHARSET = 129
Private Const OEM_CHARSET = 255

'lfPitchAndFamily Const
Private Const DEFAULT_PITCH = 0
Private Const FIXED_PITCH = 1
Private Const VARIABLE_PITCH = 2
Private Const FF_DECORATIVE = 80
Private Const FF_DONTCARE = 0
Private Const FF_MODERN = 48
Private Const FF_ROMAN = 16
Private Const FF_SCRIPT = 64
Private Const FF_SWISS = 32

Private Const LF_FACESIZE = 32

Private Declare Function EnumFontFamilies Lib "gdi32" Alias "EnumFontFamiliesA" (ByVal hdc As Long, ByVal lpszFamily As String, ByVal lpEnumFontFamProc As Long, ByVal lParam As Long) As Long
Private Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
Private Type LOGFONT
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName As String * 32
End Type

Public Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Public Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Public Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Public Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Dim curFont As LOGFONT
Dim font As Long
Dim fRect As RECT
Dim cRECT As RECT
Dim RetVal As Long

Public Sub createFONT(cHDC As Long, ccA As Integer)

With curFont
    .lfHeight = -(ccA)
    .lfWidth = 0
    .lfEscapement = 0
    .lfOrientation = 0
    .lfWeight = 400
    .lfItalic = 0
    .lfUnderline = 0
    .lfStrikeOut = 0
    .lfCharSet = DEFAULT_CHARSET
    .lfOutPrecision = 2
    .lfClipPrecision = 1
    .lfQuality = 0
    .lfPitchAndFamily = FF_SWISS
    EnumFontFamilies cHDC, .lfFaceName, 0&, 0&
    '.lfFaceName = "Courier"
End With
    
    font = CreateFontIndirect(curFont)
    
    SelectObject cHDC, font
    SetTextColor cHDC, RGB(0, 0, 0)
    DeleteObject font
End Sub

Public Sub mDrawText(cHDC As Long, tX As Long, tY As Long, cTEXT As String, fSize As Integer, mColor As Long, Optional wFormat As Long)
createFONT cHDC, fSize

'----TEXT----

'SetBkColor cHDC, RGB(255, 0, 0)
SetTextColor cHDC, mColor
SetBkMode cHDC, 0
With fRect
    .Left = tX
    .Right = tX + (9 * fSize * Len(cTEXT))
    .Top = tY
    .Bottom = tY + (fSize) + 5
    'RetVal = Rectangle(cHDC, .Left, .Top, .Right, .Bottom)
End With

    RetVal = DrawText(cHDC, cTEXT, Len(cTEXT), fRect, wFormat)
'----END TEXT----
End Sub

